Index: common/multi_euc.c
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/common/multi_euc.c	Wed Aug 20 16:32:44 1997
***************
*** 0 ****
--- 1,432 ----
+ /*
+  * multilingual support for nvi
+  * Copyright(c) 1996, 1997 by Jun-ichiro Itoh.  All rights reserved.
+  * Author contact: <itojun@mt.cs.keio.ac.jp>
+  * $Id: multi_euc.c,v 1.2 1997/08/20 07:32:43 itojun Exp $
+  *
+  * Freely redistributable, reusable, unless otherwise noted in accompanying
+  * document. (for example, redistribution is prohibited during alpha-test
+  * period)
+  * Absolutely no warranty.
+  *
+  * The code is based on:
+  *	jelvis japanization patch by Jun-ichiro Itoh
+  *	nvi 1.03 japanization patch by Yoshitaka Tokugawa <toku@dit.co.jp>
+  */
+ 
+ #include "config.h"
+ 
+ #ifdef MULTIBYTE
+ 
+ #include <sys/types.h>
+ #include <sys/queue.h>
+ 
+ #include <bitstring.h>
+ #include <ctype.h>
+ #include <errno.h>
+ #include <fcntl.h>
+ #include <limits.h>
+ #include <stdio.h>
+ #include <stdlib.h>
+ #include <string.h>
+ 
+ #include "../common/common.h"
+ #include "multibyte.h"
+ 
+ #if 0
+ int
+ euc_to_int(sp, e, dst, pdlen, src, slen, pflags, state)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *dst;
+ 	size_t *pdlen;
+ 	CHAR_T *src;
+ 	size_t slen;
+ 	int *pflags;
+ 	ISO2022STATE *state;
+ {
+ 	CHAR_T *p;
+ 	CHAR_T *q;
+ 	size_t i;
+ 
+ 	/* sanity check. */
+ 	if (ischarset(e->initg0)) {
+ 		if (charset(e->initg0).type != CS94)
+ 			abort();
+ 	}
+ 	if (ischarset(e->initg1)) {
+ 		if (charset(e->initg1).type != CS9494)
+ 			abort();
+ 	}
+ 	if (ischarset(e->initg2)) {
+ 		if (charset(e->initg2).type != CS94)
+ 			abort();
+ 	}
+ 	if (ischarset(e->initg3)) {
+ 		if (charset(e->initg3).type != CS9494)
+ 			abort();
+ 	}
+ 	
+ 	q = dst;
+ 	p = src;
+ 	if (pflags)
+ 		FL_INIT(*pflags, 0);
+ 
+ 	for (i = 0; i < slen; i++) {
+ 		if (i + 1 < slen && iseuckanji(p[0]) && iseuckanji(p[1])) {
+ 			if (!ischarset(e->initg1))
+ 				goto raw;
+ 
+ 			if (dst) {
+ 				*q++ = e->initg1;
+ 				*q++ = *p++ & 0x7f;
+ 				*q++ = *p++ & 0x7f;
+ 			} else {
+ 				q += 3;
+ 				p += 2;
+ 			}
+ 			i++;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (i + 1 < slen && p[0] == 0x8e && iseuckanji(p[1])) {
+ 			if (!ischarset(e->initg2))
+ 				goto raw;
+ 
+ 			if (dst) {
+ 				p++;
+ 				*q++ = e->initg2;
+ 				*q++ = *p++ & 0x7f;
+ 			} else {
+ 				q += 2;
+ 				p += 2;
+ 			}
+ 			i++;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (i + 2 < slen && p[0] == 0x8f
+ 		 && iseuckanji(p[1]) && iseuckanji(p[2])) {
+ 			if (!ischarset(e->initg3))
+ 				goto raw;
+ 
+ 			if (dst) {
+ 				p++;
+ 				*q++ = e->initg3;
+ 				*q++ = *p++ & 0x7f;
+ 				*q++ = *p++ & 0x7f;
+ 			} else {
+ 				q += 3;
+ 				p += 3;
+ 			}
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 
+ raw:
+ 		/*
+ 		 * ASCII and other binary encodings.
+ 		 */
+ 		if (p[0] & 0x80) {
+ 			if (dst) {
+ 				*q++ = CS_RAW0 + v_key_len(sp, *p);
+ 				*q++ = *p & 0x7f;
+ 				p++;
+ 			} else {
+ 				q += 2;
+ 				p++;
+ 			}
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_RAW);
+ 			continue;
+ 		}
+ 
+ 		if (dst)
+ 			*q++ = *p++;
+ 		else {
+ 			q++;
+ 			p++;
+ 		}
+ 	}
+ 
+ 	if (pdlen)
+ 		*pdlen = q - dst;
+ 	return 0;
+ }
+ #endif
+ 
+ #if 0
+ int
+ int_to_euc(sp, e, dst, pdlen, src, slen, pflags, state)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *dst;
+ 	size_t *pdlen;
+ 	CHAR_T *src;
+ 	size_t slen;
+ 	int *pflags;
+ 	ISO2022STATE *state;
+ {
+ 	CHAR_T *p;
+ 	CHAR_T *q;
+ 	size_t i;
+ 
+ 	/* sanity check. */
+ 	if (ischarset(e->initg0)) {
+ 		if (charset(e->initg0).type != CS94)
+ 			abort();
+ 	}
+ 	if (ischarset(e->initg1)) {
+ 		if (charset(e->initg1).type != CS9494)
+ 			abort();
+ 	}
+ 	if (ischarset(e->initg2)) {
+ 		if (charset(e->initg2).type != CS94)
+ 			abort();
+ 	}
+ 	if (ischarset(e->initg3)) {
+ 		if (charset(e->initg3).type != CS9494)
+ 			abort();
+ 	}
+ 	
+ 	if (pflags)
+ 		FL_INIT(*pflags, 0);
+ 	q = dst;
+ 	p = src;
+ 
+ 	for (i = 0; i < slen; i++) {
+ 		if (CS_RAW(p[0])) {
+ 			if (dst) {
+ 				*q++ = p[1] | 0x80;
+ 				p += 2;
+ 			} else {
+ 				q++;
+ 				p += 2;
+ 			}
+ 			i++;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_RAW);
+ 			continue;
+ 		}
+ 		if (ischarset(e->initg1) && p[0] == e->initg1) {
+ 			/*
+ 			 * If we're using euc-jp, there's no distinction
+ 			 * between JIS0208 variants.
+ 			 */
+ 			if (dst) {
+ 				p++;
+ 				*q++ = *p++ | 0x80;
+ 				*q++ = *p++ | 0x80;
+ 			} else {
+ 				q += 2;
+ 				p += 3;
+ 			}
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (ischarset(e->initg2) && p[0] == e->initg2) {
+ 			if (dst) {
+ 				p++;
+ 				*q++ = 0x8e;
+ 				*q++ = *p++ | 0x80;
+ 			} else {
+ 				q += 2;
+ 				p += 2;
+ 			}
+ 			i++;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (ischarset(e->initg3) && p[0] == e->initg3) {
+ 			if (dst) {
+ 				p++;
+ 				*q++ = 0x8f;
+ 				*q++ = *p++ | 0x80;
+ 				*q++ = *p++ | 0x80;
+ 			} else {
+ 				q += 3;
+ 				p += 3;
+ 			}
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (p[0] & 0x80) {
+ 			/*
+ 			 * Unknown encoding.  Simply skip them.
+ 			 */
+ 			p += charset(p[0]).blen;
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_SKIP);
+ 			continue;
+ 		}
+ 
+ 		if (dst)
+ 			*q++ = *p++;
+ 		else {
+ 			q++;
+ 			p++;
+ 		}
+ 	}
+ 
+ 	if (pdlen)
+ 		*pdlen = q - dst;
+ 	return 0;
+ }
+ #endif
+ 
+ int
+ euc_recommendation(cs, e)
+ 	CHARSET const *cs;
+ 	ENCODING const *e;
+ {
+ 	CHAR_T ch;
+ 
+ 	if (cs == NULL)
+ 		return 0;
+ 
+ 	ch = CS_RAW0 + (cs - charsettab);
+ 	if (ch == e->initg1)
+ 		return 1;
+ 	if (ch == e->initg2)
+ 		return 2;
+ 	if (ch == e->initg3)
+ 		return 3;
+ 	if (!ischarset(e->initg2) && (cs->type == CS94 || cs->type == CS96))
+ 		return 2;
+ 	if (!ischarset(e->initg3) && (cs->type == CS9494 || cs->type == CS9696))
+ 		return 3;
+ 	
+ 	/* don't mix them up with GR chars... */
+ 	return 0;
+ }
+ 
+ #if 0
+ void
+ euc_keyinput(sp, e, kbuf, kbuflen, intbuf, pintbuflen, pstate, pconsumed)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *kbuf;
+ 	size_t kbuflen;
+ 	CHAR_T *intbuf;
+ 	size_t *pintbuflen;
+ 	int *pstate;
+ 	size_t *pconsumed;
+ {
+ 	size_t i;
+ 	size_t j;
+ 	size_t consumed;
+ 
+ 	i = j = consumed = 0;
+ 	while (i < kbuflen) {
+ 		/*
+ 		 * Kanji cases.
+ 		 */
+ 		if (ischarset(e->initg1) && i + 1 < kbuflen
+ 		 && iseuckanji(kbuf[i]) && iseuckanji(kbuf[i + 1])) {
+ 			/*
+ 			 * we got G1 char.
+ 			 */
+ 			intbuf[j++] = e->initg1;
+ 			intbuf[j++] = kbuf[i++] & 0x7f;
+ 			intbuf[j++] = kbuf[i++] & 0x7f;
+ 			*pstate = 0;
+ 			consumed += 2;
+ 		} else if (ischarset(e->initg2) && i + 1 < kbuflen
+ 		 && kbuf[i] == 0x8e && iseuckanji(kbuf[i + 1])) {
+ 			/*
+ 			 * we got G2 char.
+ 			 */
+ 			intbuf[j++] = e->initg2;
+ 			intbuf[j++] = kbuf[i + 1] & 0x7f;
+ 			i += 2;
+ 			*pstate = 0;
+ 			consumed += 2;
+ 		} else if (ischarset(e->initg3) && i + 2 < kbuflen
+ 		 && kbuf[i] == 0x8f
+ 		 && iseuckanji(kbuf[i + 1]) && iseuckanji(kbuf[i + 2])) {
+ 			/*
+ 			 * we got G3 char.
+ 			 */
+ 			intbuf[j++] = e->initg3;
+ 			intbuf[j++] = kbuf[i + 1] & 0x7f;
+ 			intbuf[j++] = kbuf[i + 2] & 0x7f;
+ 			i += 3;
+ 			*pstate = 0;
+ 			consumed += 3;
+ 		} else if (i + 1 == kbuflen && iseuckanji(kbuf[i])) {
+ 			/*
+ 			 * Only the firstbyte for G1 char is available.
+ 			 * Keep this kanji char till next round.
+ 			 */
+ 			i++;
+ 			*pstate = 1;
+ 		} else if (i + 1 == kbuflen && kbuf[i] == 0x8e) {
+ 			/*
+ 			 * Only the firstbyte for G2 char is available.
+ 			 * Keep this kanji char till next round.
+ 			 */
+ 			i++;
+ 			*pstate = 2;
+ 		} else if (i + 1 == kbuflen && kbuf[i] == 0x8f) {
+ 			/*
+ 			 * Only the firstbyte for G3 char is available.
+ 			 * Keep this kanji char till next round.
+ 			 */
+ 			i++;
+ 			*pstate = 3;
+ 		} else if (i + 2 == kbuflen
+ 		 && kbuf[i] == 0x8f && iseuckanji(kbuf[i + 1])) {
+ 			/*
+ 			 * Only the 1st and 2nd byte for G3 char is available.
+ 			 * Keep this kanji char till next round.
+ 			 */
+ 			i += 2;
+ 			*pstate = 4;
+ 		}
+ 
+ 		/*
+ 		 * Non-kanji cases.
+ 		 */
+ 		else if (kbuf[i] & 0x80) {
+ 			intbuf[j++] = CS_RAW0 + v_key_len(sp, kbuf[i]);
+ 			intbuf[j++] = kbuf[i] & 0x7f;
+ 			i++;
+ 			*pstate = 0;
+ 			consumed++;
+ 		} else {
+ 			intbuf[j++] = kbuf[i++];
+ 			*pstate = 0;
+ 			consumed++;
+ 		}
+ 	}
+ 	*pintbuflen = j;
+ 	*pconsumed = consumed;
+ }
+ #endif
+ 
+ int
+ euc_display(sp, e, name, p)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *name;
+ 	CHAR_T *p;
+ {
+ 	if (ischarset(e->initg1) && p[0] == e->initg1) {
+ 		name[0] = p[1] | 0x80;
+ 		name[1] = p[2] | 0x80;
+ 		name[2] = '\0';
+ 		return 1;
+ 	}
+ 	return 0;
+ }
+ #endif /*MULTIBYTE*/
Index: common/multi_eucjp.c
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/common/multi_eucjp.c	Wed Aug 20 16:33:36 1997
***************
*** 0 ****
--- 1,158 ----
+ /*
+  * multilingual support for nvi
+  * Copyright(c) 1996, 1997 by Jun-ichiro Itoh.  All rights reserved.
+  * Author contact: <itojun@mt.cs.keio.ac.jp>
+  * $Id: multi_eucjp.c,v 1.5 1997/08/20 07:33:35 itojun Exp $
+  *
+  * Freely redistributable, reusable, unless otherwise noted in accompanying
+  * document. (for example, redistribution is prohibited during alpha-test
+  * period)
+  * Absolutely no warranty.
+  *
+  * The code is based on:
+  *	jelvis japanization patch by Jun-ichiro Itoh
+  *	nvi 1.03 japanization patch by Yoshitaka Tokugawa <toku@dit.co.jp>
+  */
+ 
+ #include "config.h"
+ 
+ #ifdef MULTIBYTE
+ 
+ #include <sys/types.h>
+ #include <sys/queue.h>
+ 
+ #include <bitstring.h>
+ #include <ctype.h>
+ #include <errno.h>
+ #include <fcntl.h>
+ #include <limits.h>
+ #include <stdio.h>
+ #include <stdlib.h>
+ #include <string.h>
+ 
+ #include "../common/common.h"
+ #include "multibyte.h"
+ 
+ #if 0
+ int
+ int_to_eucjp(sp, e, dst, pdlen, src, slen, pflags, state)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *dst;
+ 	size_t *pdlen;
+ 	CHAR_T *src;
+ 	size_t slen;
+ 	int *pflags;
+ 	ISO2022STATE *state;
+ {
+ 	CHAR_T *p;
+ 	CHAR_T *q;
+ 	size_t i;
+ 
+ 	if (pflags)
+ 		FL_INIT(*pflags, 0);
+ 	q = dst;
+ 	p = src;
+ 
+ 	for (i = 0; i < slen; i++) {
+ 		if (CS_RAW(p[0])) {
+ 			if (dst) {
+ 				*q++ = p[1] | 0x80;
+ 				p += 2;
+ 			} else {
+ 				q++;
+ 				p += 2;
+ 			}
+ 			i++;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_RAW);
+ 			continue;
+ 		}
+ 		if (p[0] == CS_JISX0208_1983 || p[0] == CS_JISX0208_1978) {
+ 			/*
+ 			 * If we're using euc-jp, there's no distinction
+ 			 * between JIS0208 variants.
+ 			 */
+ 			if (dst) {
+ 				p++;
+ 				*q++ = *p++ | 0x80;
+ 				*q++ = *p++ | 0x80;
+ 			} else {
+ 				q += 2;
+ 				p += 3;
+ 			}
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (p[0] == CS_JISX0201_RIGHT) {
+ 			if (dst) {
+ 				p++;
+ 				*q++ = 0x8e;
+ 				*q++ = *p++ | 0x80;
+ 			} else {
+ 				q += 2;
+ 				p += 2;
+ 			}
+ 			i++;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (p[0] == CS_JISX0212_1990) {
+ 			if (dst) {
+ 				p++;
+ 				*q++ = 0x8f;
+ 				*q++ = *p++ | 0x80;
+ 				*q++ = *p++ | 0x80;
+ 			} else {
+ 				q += 3;
+ 				p += 3;
+ 			}
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (p[0] & 0x80) {
+ 			/*
+ 			 * Unknown encoding.  Simply skip them.
+ 			 */
+ 			p += charset(p[0]).blen;
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_SKIP);
+ 			continue;
+ 		}
+ 
+ 		if (dst)
+ 			*q++ = *p++;
+ 		else {
+ 			q++;
+ 			p++;
+ 		}
+ 	}
+ 
+ 	if (pdlen)
+ 		*pdlen = q - dst;
+ 	return 0;
+ }
+ #endif
+ 
+ int
+ eucjp_display(sp, e, name, p)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *name;
+ 	CHAR_T *p;
+ {
+ 	if (p[0] == CS_JISX0208_1983 || p[0] == CS_JISX0208_1978) {
+ 		name[0] = p[1] | 0x80;
+ 		name[1] = p[2] | 0x80;
+ 		name[2] = '\0';
+ 		return 1;
+ 	}
+ 	return 0;
+ }
+ #endif /*MULTIBYTE*/
Index: common/multi_euctw.c
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/common/multi_euctw.c	Wed Apr  2 16:54:25 1997
***************
*** 0 ****
--- 1,371 ----
+ /*
+  * multilingual support for nvi
+  * Copyright(c) 1996, 1997 by Jun-ichiro Itoh.  All rights reserved.
+  * Author contact: <itojun@mt.cs.keio.ac.jp>
+  * $Id: multi_euctw.c,v 1.1 1997/03/30 04:10:15 itojun Exp $
+  *
+  * Freely redistributable, reusable, unless otherwise noted in accompanying
+  * document. (for example, redistribution is prohibited during alpha-test
+  * period)
+  * Absolutely no warranty.
+  *
+  * The code is based on:
+  *	jelvis japanization patch by Jun-ichiro Itoh
+  *	nvi 1.03 japanization patch by Yoshitaka Tokugawa <toku@dit.co.jp>
+  */
+ 
+ #include "config.h"
+ 
+ #ifdef MULTIBYTE
+ 
+ #include <sys/types.h>
+ #include <sys/queue.h>
+ 
+ #include <bitstring.h>
+ #include <ctype.h>
+ #include <errno.h>
+ #include <fcntl.h>
+ #include <limits.h>
+ #include <stdio.h>
+ #include <stdlib.h>
+ #include <string.h>
+ 
+ #include "../common/common.h"
+ #include "multibyte.h"
+ 
+ int
+ euctw_to_int(sp, e, dst, pdlen, src, slen, pflags, state)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *dst;
+ 	size_t *pdlen;
+ 	CHAR_T *src;
+ 	size_t slen;
+ 	int *pflags;
+ 	ISO2022STATE *state;
+ {
+ 	CHAR_T *p;
+ 	CHAR_T *q;
+ 	size_t i;
+ 	static CHAR_T cnstab[] = {
+ 		0,					/*0xa0*/
+ 		CS_CNS11643_1, CS_CNS11643_2,
+ 		CS_CNS11643_3, CS_CNS11643_4,
+ 		CS_CNS11643_5, CS_CNS11643_6,
+ 		CS_CNS11643_7
+ 	};
+ #define	iscnscode(x)	\
+ 	(0xa0 <= (x)							\
+ 		&& (x) < 0xa0 + sizeof(cnstab)/sizeof(cnstab[0])	\
+ 		&& cnstab[(x) - 0xa0])
+ #define	cnscode(x)	cnstab[(x) - 0xa0]
+ 
+ 	q = dst;
+ 	p = src;
+ 	if (pflags)
+ 		FL_INIT(*pflags, 0);
+ 
+ 	for (i = 0; i < slen; i++) {
+ 		if (i + 1 < slen && iseuckanji(p[0]) && iseuckanji(p[1])) {
+ 			if (dst) {
+ 				*q++ = CS_CNS11643_1;
+ 				*q++ = *p++ & 0x7f;
+ 				*q++ = *p++ & 0x7f;
+ 			} else {
+ 				q += 3;
+ 				p += 2;
+ 			}
+ 			i++;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if (i + 3 < slen && p[0] == 0x8e && iscnscode(p[1])
+ 		 && iseuckanji(p[2]) && iseuckanji(p[3])) {
+ 			if (dst) {
+ 				p++;
+ 				*q++ = cnscode(*p); p++;
+ 				*q++ = *p++ & 0x7f;
+ 				*q++ = *p++ & 0x7f;
+ 			} else {
+ 				q += 3;
+ 				p += 4;
+ 			}
+ 			i += 3;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 
+ raw:
+ 		/*
+ 		 * ASCII and other binary encodings.
+ 		 */
+ 		if (p[0] & 0x80) {
+ 			if (dst) {
+ 				*q++ = CS_RAW0 + v_key_len(sp, *p);
+ 				*q++ = *p & 0x7f;
+ 				p++;
+ 			} else {
+ 				q += 2;
+ 				p++;
+ 			}
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_RAW);
+ 			continue;
+ 		}
+ 
+ 		if (dst)
+ 			*q++ = *p++;
+ 		else {
+ 			q++;
+ 			p++;
+ 		}
+ 	}
+ 
+ 	if (pdlen)
+ 		*pdlen = q - dst;
+ 	return 0;
+ #undef iscnscode
+ #undef cnscode
+ }
+ 
+ int
+ int_to_euctw(sp, e, dst, pdlen, src, slen, pflags, state)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *dst;
+ 	size_t *pdlen;
+ 	CHAR_T *src;
+ 	size_t slen;
+ 	int *pflags;
+ 	ISO2022STATE *state;
+ {
+ 	CHAR_T *p;
+ 	CHAR_T *q;
+ 	size_t i;
+ 	static CHAR_T cnstab[] = {
+ 		CS_CNS11643_1, CS_CNS11643_2,
+ 		CS_CNS11643_3, CS_CNS11643_4,
+ 		CS_CNS11643_5, CS_CNS11643_6,
+ 		CS_CNS11643_7
+ 	};
+ 	static CHAR_T cnscode[] =  {
+ 		0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7
+ 	};
+ 	int cnsidx;
+ 
+ 	if (pflags)
+ 		FL_INIT(*pflags, 0);
+ 	q = dst;
+ 	p = src;
+ 
+ 	for (i = 0; i < slen; i++) {
+ 		if (CS_RAW(p[0])) {
+ 			if (dst) {
+ 				*q++ = p[1] | 0x80;
+ 				p += 2;
+ 			} else {
+ 				q++;
+ 				p += 2;
+ 			}
+ 			i++;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_RAW);
+ 			continue;
+ 		}
+ 		if (p[0] == CS_CNS11643_1) {
+ 			if (dst) {
+ 				p++;
+ 				*q++ = *p++ | 0x80;
+ 				*q++ = *p++ | 0x80;
+ 			} else {
+ 				q += 2;
+ 				p += 3;
+ 			}
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 
+ 		/*
+ 		 * special processing for G2 charsets....
+ 		 */
+ 		cnsidx = -1;
+ 	    {
+ 		size_t t;
+ 		for (t = 0;
+ 		     t < sizeof(cnscode)/sizeof(cnscode[0]);
+ 		     t++) {
+ 			if (p[0] == cnstab[t]) {
+ 				cnsidx = t;
+ 				break;
+ 			}
+ 		}
+ 	    }
+ 		if (cnsidx != -1) {
+ 			if (dst) {
+ 				p++;
+ 				*q++ = cnscode[cnsidx];
+ 				*q++ = *p++ | 0x80;
+ 				*q++ = *p++ | 0x80;
+ 			} else {
+ 				q += 3;
+ 				p += 2;
+ 			}
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 
+ 		if (p[0] & 0x80) {
+ 			/*
+ 			 * Unknown encoding.  Simply skip them.
+ 			 */
+ 			p += charset(p[0]).blen;
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_SKIP);
+ 			continue;
+ 		}
+ 
+ 		if (dst)
+ 			*q++ = *p++;
+ 		else {
+ 			q++;
+ 			p++;
+ 		}
+ 	}
+ 
+ 	if (pdlen)
+ 		*pdlen = q - dst;
+ 	return 0;
+ }
+ 
+ void
+ euctw_keyinput(sp, e, kbuf, kbuflen, intbuf, pintbuflen, pstate, pconsumed)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *kbuf;
+ 	size_t kbuflen;
+ 	CHAR_T *intbuf;
+ 	size_t *pintbuflen;
+ 	int *pstate;
+ 	size_t *pconsumed;
+ {
+ 	size_t i;
+ 	size_t j;
+ 	size_t consumed;
+ 	static CHAR_T cnstab[] = {
+ 		0,					/*0xa0*/
+ 		CS_CNS11643_1, CS_CNS11643_2,
+ 		CS_CNS11643_3, CS_CNS11643_4,
+ 		CS_CNS11643_5, CS_CNS11643_6,
+ 		CS_CNS11643_7
+ 	};
+ #define	iscnscode(x)	\
+ 	(0xa0 <= (x)						\
+ 		&& (x) < sizeof(cnstab)/sizeof(cnstab[0])	\
+ 		&& cnstab[(x) - 0xa0])
+ #define	cnscode(x)	cnstab[(x) - 0xa0]
+ 
+ 	i = j = consumed = 0;
+ 	while (i < kbuflen) {
+ 		/*
+ 		 * Kanji cases.
+ 		 */
+ 		if (i + 1 < kbuflen
+ 		 && iseuckanji(kbuf[i]) && iseuckanji(kbuf[i + 1])) {
+ 			/*
+ 			 * we got G1 char.
+ 			 */
+ 			intbuf[j++] = CS_CNS11643_1;
+ 			intbuf[j++] = kbuf[i++] & 0x7f;
+ 			intbuf[j++] = kbuf[i++] & 0x7f;
+ 			*pstate = 0;
+ 			consumed += 2;
+ 		} else if (i + 2 < kbuflen
+ 		 && kbuf[i] == 0x8e && iscnscode(kbuf[i + 1])
+ 		 && iseuckanji(kbuf[i + 2]) && iseuckanji(kbuf[i + 3])) {
+ 			/*
+ 			 * we got G2 char.
+ 			 */
+ 			intbuf[j++] = cnscode(kbuf[i + 1]);
+ 			intbuf[j++] = kbuf[i + 2] & 0x7f;
+ 			intbuf[j++] = kbuf[i + 3] & 0x7f;
+ 			i += 4;
+ 			*pstate = 0;
+ 			consumed += 4;
+ 		} else if (i + 1 == kbuflen && iseuckanji(kbuf[i])) {
+ 			/*
+ 			 * Only the firstbyte for G1 char is available.
+ 			 * Keep this kanji char till next round.
+ 			 */
+ 			i++;
+ 			*pstate = 1;
+ 		} else if (i + 1 == kbuflen && kbuf[i] == 0x8e) {
+ 			/*
+ 			 * Only the firstbyte for G2 char is available.
+ 			 * Keep this kanji char till next round.
+ 			 */
+ 			i++;
+ 			*pstate = 2;
+ 		} else if (i + 2 == kbuflen && kbuf[i] == 0x8e
+ 		 && iscnscode(kbuf[i + 1])) {
+ 			/*
+ 			 * Only the first/second byte for G2 char are
+ 			 * available.
+ 			 * keep them till next round.
+ 			 */
+ 			i += 2;
+ 			*pstate = 3;
+ 		} else if (i + 3 == kbuflen && kbuf[i] == 0x8e
+ 		 && iscnscode(kbuf[i + 1]) && iseuckanji(kbuf[i + 2])) {
+ 			/*
+ 			 * Only the first/second/third byte for G2 char are
+ 			 * available.
+ 			 * keep them till next round.
+ 			 */
+ 			i += 3;
+ 			*pstate = 4;
+ 		}
+ 
+ 		/*
+ 		 * Non-kanji cases.
+ 		 */
+ 		else if (kbuf[i] & 0x80) {
+ 			intbuf[j++] = CS_RAW0 + v_key_len(sp, kbuf[i]);
+ 			intbuf[j++] = kbuf[i] & 0x7f;
+ 			i++;
+ 			*pstate = 0;
+ 			consumed++;
+ 		} else {
+ 			intbuf[j++] = kbuf[i++];
+ 			*pstate = 0;
+ 			consumed++;
+ 		}
+ 	}
+ 	*pintbuflen = j;
+ 	*pconsumed = consumed;
+ #undef iscnscode
+ #undef cnscode
+ }
+ 
+ int
+ euctw_display(sp, e, name, p)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *name;
+ 	CHAR_T *p;
+ {
+ 	if (p[0] == CS_CNS11643_1) {
+ 		name[0] = p[1] | 0x80;
+ 		name[1] = p[2] | 0x80;
+ 		name[2] = '\0';
+ 		return 1;
+ 	}
+ 	return 0;
+ }
+ #endif /*MULTIBYTE*/
Index: common/multi_hz.c
*** /dev/null	Wed Aug 20 14:47:14 1997
--- nvi-1.79-m17n/common/multi_hz.c	Wed Apr  2 16:54:26 1997
***************
*** 0 ****
--- 1,261 ----
+ /*
+  * multilingual support for nvi
+  * Copyright(c) 1996, 1997 by Jun-ichiro Itoh.  All rights reserved.
+  * Author contact: <itojun@mt.cs.keio.ac.jp>
+  * $Id: multi_hz.c,v 1.2 1997/04/02 04:25:12 itojun Exp $
+  *
+  * Freely redistributable, reusable, unless otherwise noted in accompanying
+  * document. (for example, redistribution is prohibited during alpha-test
+  * period)
+  * Absolutely no warranty.
+  *
+  * The code is based on:
+  *	jelvis japanization patch by Jun-ichiro Itoh
+  *	nvi 1.03 japanization patch by Yoshitaka Tokugawa <toku@dit.co.jp>
+  */
+ 
+ #include "config.h"
+ 
+ #ifdef MULTIBYTE
+ 
+ #include <sys/types.h>
+ #include <sys/queue.h>
+ 
+ #include <bitstring.h>
+ #include <ctype.h>
+ #include <errno.h>
+ #include <fcntl.h>
+ #include <limits.h>
+ #include <stdio.h>
+ #include <stdlib.h>
+ #include <string.h>
+ 
+ #include "../common/common.h"
+ #include "multibyte.h"
+ 
+ int
+ hz_to_int(sp, e, dst, pdlen, src, slen, pflags, state)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *dst;
+ 	size_t *pdlen;
+ 	CHAR_T *src;
+ 	size_t slen;
+ 	int *pflags;
+ 	ISO2022STATE *state;
+ {
+ 	CHAR_T *p;
+ 	CHAR_T *q;
+ 	size_t i;
+ 	u_short ch;
+ 	CHAR_T cs;
+ 
+ 	q = dst;
+ 	p = src;
+ 	if (pflags)
+ 		FL_INIT(*pflags, 0);
+ 	cs = CS_NONE;
+ 
+ 	for (i = 0; i < slen; i++) {
+ 		if (p[0] == '~') {
+ 			if (i + 1 < slen && p[1] == '~') {
+ 				/*
+ 				 * Double tilde: escapes single tilde
+ 				 */
+ 				p += 2;
+ 				if (dst)
+ 					*q++ = '~';
+ 				else
+ 					q++;
+ 				i++;	/*plus one at for loop*/
+ 				if (pflags)
+ 					FL_SET(*pflags, MB_MULTIBYTE);
+ 				continue;
+ 			}
+ 			if (i + 1 < slen && p[1] == '{' && cs == CS_NONE) {
+ 				/*
+ 				 * tilde open-bracket: enter HZ
+ 				 */
+ 				p += 2;
+ 				cs = CS_GB2312;
+ 				i++;	/*plus one at for loop*/
+ 				if (pflags)
+ 					FL_SET(*pflags, MB_MULTIBYTE);
+ 				continue;
+ 			}
+ 			if (i + 1 < slen && p[1] == '}' && cs == CS_GB2312) {
+ 				/*
+ 				 * tilde close: enter ASCII
+ 				 */
+ 				p += 2;
+ 				cs = CS_NONE;
+ 				i++;	/*plus one at for loop*/
+ 				if (pflags)
+ 					FL_SET(*pflags, MB_MULTIBYTE);
+ 				continue;
+ 			}
+ 			if (i + 1 == slen) {
+ 				/*
+ 				 * tilde on EOL: join the line to the next one
+ 				 */
+ 				p++;
+ 				if (pflags)
+ 					FL_SET(*pflags, MB_MULTIBYTE|MB_JOIN);
+ 				continue;
+ 			}
+ 		}
+ 		if (cs == CS_GB2312) {
+ 			if (! (0x21 <= p[0] && p[0] <= 0x7e
+ 			    && 0x21 <= p[1] && p[1] <= 0x7e))
+ 				goto raw;
+ 
+ 			if (dst) {
+ 				*q++ = cs;
+ 				*q++ = *p++;
+ 				*q++ = *p++;
+ 			} else {
+ 				q += 3;
+ 				p += 2;
+ 			}
+ 			i++;	/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		
+ raw:
+ 		/*
+ 		 * ASCII and other binary chars.
+ 		 */
+ 		if (p[0] & 0x80) {
+ 			if (dst) {
+ 				*q++ = CS_RAW0 + v_key_len(sp, p[0]);
+ 				*q++ = *p++ & 0x7f;
+ 			} else {
+ 				q += 2;
+ 				p++;
+ 			}
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_RAW);
+ 			continue;
+ 		}
+ 
+ 		if (dst)
+ 			*q++ = *p++;
+ 		else {
+ 			q++;
+ 			p++;
+ 		}
+ 	}
+ 
+ 	if (pdlen)
+ 		*pdlen = q - dst;
+ 	return 0;
+ }
+ 
+ int
+ int_to_hz(sp, e, dst, pdlen, src, slen, pflags, state)
+ 	SCR *sp;
+ 	ENCODING const *e;
+ 	CHAR_T *dst;
+ 	size_t *pdlen;
+ 	CHAR_T *src;
+ 	size_t slen;
+ 	int *pflags;
+ 	ISO2022STATE *state;
+ {
+ 	CHAR_T *p;
+ 	CHAR_T *q;
+ 	size_t i;
+ 	u_short ch;
+ 	CHAR_T cs;
+ 
+ 	if (pflags)
+ 		FL_INIT(*pflags, 0);
+ 	q = dst;
+ 	p = src;
+ 	cs = CS_NONE;
+ 
+ 	for (i = 0; i < slen; i++) {
+ 		if (p[0] == CS_GB2312) {
+ 			if (cs != CS_NONE) {
+ 				if (dst) {
+ 					*q++ = '~';
+ 					*q++ = '{';
+ 				} else
+ 					q += 2;
+ 				cs = CS_GB2312;
+ 			}
+ 
+ 			if (dst) {
+ 				p++;
+ 				*q++ = *p++;
+ 				*q++ = *p++;
+ 			} else {
+ 				p += 3;
+ 				q += 2;
+ 			}
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 			continue;
+ 		}
+ 		if ((p[0] & 0x80) && !CS_RAW(p[0])) {
+ 			/*
+ 			 * Unknown encoding.  Simply skip them.
+ 			 */
+ 			p += charset(p[0]).blen;
+ 			i += 2;		/*plus one at for loop*/
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_SKIP);
+ 			continue;
+ 		}
+ 
+ 		if (cs != CS_NONE) {
+ 			if (dst) {
+ 				*q++ = '~';
+ 				*q++ = '}';
+ 			} else
+ 				q += 2;
+ 			cs = CS_NONE;
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE);
+ 		}
+ 
+ 		if (CS_RAW(p[0])) {
+ 			if (dst) {
+ 				*q++ = p[1] | 0x80;
+ 				p += 2;
+ 			} else {
+ 				q++;
+ 				p += 2;
+ 			}
+ 			if (pflags)
+ 				FL_SET(*pflags, MB_MULTIBYTE|MB_RAW);
+ 			continue;
+ 		}
+ 
+ 		if (dst)
+ 			*q++ = *p++;
+ 		else {
+ 			q++;
+ 			p++;
+ 		}
+ 	}
+ 
+ 	if (cs != CS_NONE) {
+ 		if (dst) {
+ 			*q++ = '~';
+ 			*q++ = '}';
+ 		} else
+ 			q += 2;
+ 		cs = CS_NONE;
+ 		if (pflags)
+ 			FL_SET(*pflags, MB_MULTIBYTE);
+ 	}
+ 
+ 	if (pdlen)
+ 		*pdlen = q - dst;
+ 	return 0;
+ }
+ #endif /*MULTIBYTE*/
